﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Remoting.Messaging;
using System.Text;
using System.Threading.Tasks;

namespace SpongeBobCoder.EventTest
{
    public class Publisher
    {
        public event CalculatorHandler CalculatorEvent;

        public void DoSomething(double num1, double num2)
        {
            if (CalculatorEvent != null)
            {
                Delegate[] delArray = CalculatorEvent.GetInvocationList(); //获取到所有的委托方法.
                foreach (Delegate del in delArray)
                {
                    try
                    {
                        CalculatorHandler handler = del as CalculatorHandler;
                        IAsyncResult myResult = handler.BeginInvoke(num1, num2, MyCallback, "方法执行完毕,回调成功" + handler.Method.Name);
                        // Console.WriteLine("SpongeBob");
                    }
                    catch (Exception e) // 把异常吃掉
                    {
                        Console.WriteLine(e.InnerException.Message);
                    }
                }
            }
        }

        public void MyCallback(IAsyncResult asyncResult)
        {
            AsyncResult result = (AsyncResult)asyncResult;
            CalculatorHandler handler = (CalculatorHandler)result.AsyncDelegate;
            Console.WriteLine(asyncResult.AsyncState);
            Console.WriteLine("获取到执行结果为:{0} \n", handler.EndInvoke(asyncResult));
        }
    }
}
