﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SpongeBobCoder.EventTest
{
    public class Publisher
    {
        public event CalculatorHandler CalculatorEvent;

        public void DoSomething(double num1, double num2)
        {
            if (CalculatorEvent != null)
            {
                Delegate[] delArray = CalculatorEvent.GetInvocationList(); //获取到所有的委托方法.
                foreach (Delegate del in delArray)
                {
                    try
                    {
                       object obj = del.DynamicInvoke(num1, num2);
                       Console.WriteLine(obj == null);
                    }
                    catch (Exception e) // 把异常吃掉
                    {
                        Console.WriteLine(e.InnerException.Message); 
                    }
                }
            }
        }
    }
}
